function [w, a] = desa2(x)
%[w a] = desa2(x): calculate [frequency amplitude] from signal x using
%DESA-2 and TKEO.
%x should be 1-column vector
%frequency returned is in radians/sample.

y = x;
sz = size(x);
sz = sz(1);

y(2:sz-1) = x(3:sz)-x(1:sz-2); %set y(n) = x(n+1) - x(n-1)
y(1) = y(2); %pad y to be the same length as x, for simplicity
y(sz) = y(sz-1);
ty = abs(teager(y)); %Teager should always be positive; this is a precaution
tx = abs(teager(x));

w = asin(sqrt(teager(y)./(4 .* teager(x))));
a = 2 .* teager(x) ./ (sqrt(teager(y)));
