function filt = find_filt(f, NF, range)
%filt = find_filt(f, NF, range): find filter filt matching frequency f
%determine the filter number matching frequency f, from a
%logarithmic filter bank for frequencies across range.

min = log10(range(1));
max = log10(range(2));
filt = (log10(f) - min)/(max - min)*NF;
filt = ceil(filt + .5);