function s2 = gen_noise(inputimage, SNR)
%generate a noisy signal s2 from a noiseless signal inputimage, with a specific SNR
%adapted from http://my.fit.edu/~kozaitis/matlab/MatNoiseIm.html

%for zero-mean white noise:
%noiseimage = (rand(size(inputimage))-.5);

%for zero-mean Gaussian noise:
noiseimage = randn(size(inputimage)); 

Pinputimage=sum(sum(inputimage.^2)); % Power in inputimage
Pnoiseimage=sum(sum((rand(size(noiseimage))-.5).^2)); % Power in noiseimage
K = (Pinputimage/ Pnoiseimage); % Ratio of noise powers
noiseimage = sqrt(K/SNR)*(rand(size(inputimage))-.5);% Generates a noisy image with a specific SNR
s2 = noiseimage + inputimage;