%Part 4: Show how Teager operator can be used on multi-component signals
%using a filterbank

%a. Show 1-, 2-, and 3-component signals passed through filterbank and then
% "teagered"

t = 0:1/8000:500/8000;
t = t';
Fs = 8000;
limits = [250 4000];

sin1 = 10 * sin(2 * pi * t * 440);
sin2 =  sin1 + 10 * sin(2 * pi * t * 1000);
sin3 = sin2 + 10 * sin(2 * pi * t * 300);

[out1 teag1 pairs1] = myfilters1(sin1, Fs, limits);
[out2 teag2 pairs2] = myfilters1(sin2, Fs, limits);
[out3 teag3 pairs3] = myfilters1(sin3, Fs, limits);

display(sprintf('Uncomment the lines to display the waterfall graphs you wish to see.'));
display(sprintf('They are presently all commented out because of the time needed to render them.')); 

a = figure;
set(a, 'name', 'Teager analysis of filtered 440Hz signal', 'NumberTitle', 'off');
%waterfall(teag1');
a = figure;
set(a, 'name', 'Teager analysis of filtered 440Hz+1000Hz signal', 'NumberTitle', 'off');
%waterfall(teag2');
a = figure;
set(a, 'name', 'Teager analysis of filtered 440Hz+1000Hz+300Hz signal', 'NumberTitle', 'off');
%waterfall(teag3');

%b. Show real signals passed through filterbank and then "teagered"

[c3 fsw] = wavread('C3loudmonoshort.wav');
[c3out c3teag c3pairs] = myfilters1(c3(1:5000),  fsw, [20 4000]);
c3teag_graph = c3teag(1000:2000,:)';
a = figure;
set(a, 'name', 'Teager analysis of filtered piano C3', 'NumberTitle', 'off');
%waterfall(c3teag_graph);

%c. Show how DESA-2 can be used easily on a composite signal
[w3 a3 fs3 as3 pairs3 out3] = myfilters2(sin3, Fs, ([20 4000]));

a = figure;
set(a, 'name', 'Amplitude of Frequency Components, using DESA-2 and a filter  bank', 'NumberTitle', 'off');
stem(fs3', as3');

